SystemOrganization addCategory: #'Seaside-Examples-Store-Magma'!

WAComponent subclass: #WAStoreOrderView
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Magma'!

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:31'!
buildTable

	table := WATableReport new
		rowPeriod: 1;
		rowColors: #('lightblue' 'white');
		rows: self rows;
		columns: {
			WAReportColumn selector: #date title: 'Date'.
			WAReportColumn selector: #name title: 'Name'.
			WAReportColumn selector: #totalPrice title: 'Total Price'.
		}! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:07'!
children

	^ Array with: table! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:07'!
initialize

	super initialize.
	self buildTable! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'cmm 11/2/2005 21:16'!
renderContentOn: html

	html form:
		[ html heading: 'Orders' level: 3.
		html render: table.
		html submitButtonWithAction: [ self answer ] text: 'Done' ]! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:10'!
rows

	^ self session root orders read: #date! !

WAComponent subclass: #WAStoreRepository
	instanceVariableNames: 'inventory orders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Magma'!

!WAStoreRepository commentStamp: 'kph 8/12/2006 03:00' prior: 0!
This class provides the root of a Magma repository to be used with the Seaside Store example.

It replaces WAStoreInventory. It maintains two indexed MagmaCollections: inventory & orders.

!

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'kph 8/23/2006 19:35'!
magmaRootClass

^ self ! !

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'kph 8/21/2006 05:06'!
magmaRootDescription
 
^'This class provides the root of a Magma repository to be used with the Seaside Store example.
It replaces WAStoreInventory. It maintains two indexed MagmaCollections: inventory & orders.'
 ! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'cmm 11/1/2005 00:37'!
initializeInventory

	"Create the MagmaCollection and its indices"
	inventory := MagmaCollection new
		addIndex: ((MaSearchStringIndex attribute: #title) keySize: 128; yourself) ;
		addIndex: ((MaKeywordIndex attribute: #keywords) keySize: 64; yourself) ;
		yourself.

	"Use the original class to populate the collection..."
	WAStoreInventory new allItems do: [ :item | inventory add: item  ].
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'kph 9/5/2006 12:23'!
initializeOrders

	orders := MagmaCollection  new 
		addIndex: ((MaSearchStringIndex attribute: #name) keySize: 128; yourself);
		addIndex: (MaDateIndex attribute: #date);
		yourself.
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2006 12:10'!
initializeRepository

	super initialize.
	self 
		initializeInventory; 
		initializeOrders
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:09'!
inventory

	^ inventory! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'kph 8/24/2006 02:28'!
magmaControlPanelOn: magmaSession

"presents myself as a seaside component to be a UI to this repository.
 Since the seaside component and the repository are the same, and we do not wish to 
accidentally persist the session, we discard/ignore it here."

^ self! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:09'!
orders

	^ orders! !

!WAStoreRepository methodsFor: 'rendering' stamp: 'kph 8/15/2006 03:07'!
renderContentOn: html

self inventory ifNil: [ self renderInitializationOptionsOn: html ]
 			ifNotNil: [ self renderStatsOn: html ]! !

!WAStoreRepository methodsFor: 'rendering' stamp: 'kph 8/13/2006 02:08'!
rendererClass

^ WARenderCanvas! !

!WAStoreRepository methodsFor: 'rendering' stamp: 'kph 8/15/2006 03:04'!
renderInitializationOptionsOn: html

html text: 'Repository has not yet been initialized. This example will be initialized with an example dataset.'.
html break.

html form: [ html submitButton callback: [ self initializeRepository ] ; text: 'Initialize' ]
! !

!WAStoreRepository methodsFor: 'rendering' stamp: 'kph 8/15/2006 03:04'!
renderStatsOn: html

html heading level: 4 ; with: [ html text: 'StoreRepository' ].

html bold: 'inventory: '. html text: inventory size asString.
html break.
html bold: 'orders:'.  html text: orders size asString.! !

Object subclass: #WAOrder
	instanceVariableNames: 'dateAndTime cart shippingAddress billingAddress creditCard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Magma'!

!WAOrder commentStamp: '<historical>' prior: 0!
WAStoreRepository maintains a collection of WAOrder instances indexed by Date.!

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
billingAddress

	^ billingAddress! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
billingAddress: aWAStoreAddress 

	billingAddress := aWAStoreAddress ! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
cart

	^ cart! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
cart: aWAStoreCart 

	^ cart := aWAStoreCart! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:53'!
creditCard

	^ creditCard! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:53'!
creditCard: aWAStoreCreditCard

	creditCard := aWAStoreCreditCard! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 14:01'!
date

	^ self dateAndTime asDate! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:38'!
dateAndTime

	^ dateAndTime ifNil: [ dateAndTime := DateAndTime now ]! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:58'!
name

	^ self shippingAddress name! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:28'!
price

	^ 5.4! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
shippingAddress

	^ shippingAddress! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
shippingAddress: aWAStoreAddress 

	shippingAddress := aWAStoreAddress ! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:30'!
totalPrice

	^ self cart totalPrice! !

!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'brp 10/28/2005 11:30'!
initialize

	| application |
	application := self registerAsApplication: 'store'.
	application configuration 
		addAncestor: WAMagmaConfiguration new.

	^ application! !

!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'brp 10/28/2005 11:40'!
repositoryPath

	^ WAMagmaConfiguration new valueAt: #repositoryPath! !

!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'brp 11/4/2005 12:29'!
workspace
	"WAStore workspace"
'"-----------------------------------------------------------------------------------------------------------------
 Create the Magma repository in a local directory
-----------------------------------------------------------------------------------------------------------------"
WAStoreRepository create.

"-----------------------------------------------------------------------------------------------------------------
 Open the repository with a local session.
-----------------------------------------------------------------------------------------------------------------"
session := MagmaLocalLocation default newSession.
session connectAs: ''brp''.

"-----------------------------------------------------------------------------------------------------------------
 Explore the repository
-----------------------------------------------------------------------------------------------------------------"
session root explore.
session root inventory size.			"40"
session root orders size.				"0"
session root inventory anyOne explore.

"-----------------------------------------------------------------------------------------------------------------
 Interrogate the inventory...
-----------------------------------------------------------------------------------------------------------------"
Transcript clear.
session root inventory do: [ :x | Transcript show: x; cr ].
(session root inventory read: #title at: ''Uni'' ) do: [ :x | Transcript show: x; cr ].
(session root inventory read: #title from: ''Sake'' to: ''Tai'') do: [ :x | Transcript show: x; cr ].

"-----------------------------------------------------------------------------------------------------------------
 Close the repository.
-----------------------------------------------------------------------------------------------------------------"
session disconnectAndClose. 
session := nil. 
Smalltalk garbageCollect. MagmaSession allInstances. "should be #()"

"-----------------------------------------------------------------------------------------------------------------
 Initialise the WAStore application and start Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAStore initialize.
WAKom startOn: 8080.

"-----------------------------------------------------------------------------------------------------------------
 Once you have made an order via WAStore, you can connect to the repository
 via the controller managed by WAMagmaSession.
-----------------------------------------------------------------------------------------------------------------"
session := MagmaLocalLocation default newSession.
session connectAs: ''brp''.

session root orders size.
(session root orders read: #date) anyOne.

session disconnect. session := nil.

"-----------------------------------------------------------------------------------------------------------------
 Stop Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAKom stop.
MagmaRepositoryController initialize.  "closes all repositories."

"-----------------------------------------------------------------------------------------------------------------
 Delete the repository.
-----------------------------------------------------------------------------------------------------------------"
WAStoreRepository delete.
'
	openInWorkspaceWithTitle: 'The Sushi Store: Seaside meets Magma'


! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'brp 10/28/2005 13:13'!
browse
	"Read the entire Magma collection"

	self displayItems: (self inventory read: #title)! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'cmm 11/2/2005 21:20'!
hasOrders
	^ self session root orders notEmpty! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'kph 6/16/2006 03:28'!
inventory

	^ self session root inventory ! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'brp 7/7/2006 18:12'!
renderNavBarOn: html
	html form: [
		html bold: 'Search:'.
		html space.
		html textInput callback: [:v | self search: v]; value: '' ].
	html anchor callback: [self browse]; text: 'Browse'.
	self hasOrders ifTrue: [ 
		html break. 
		html anchor callback: [ self showOrders ]; text: 'Orders' ].
	cart hasItems ifTrue:  [
		html break.
		html anchor callback: [self checkout]; text: 'Checkout']
! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'kph 9/5/2006 12:20'!
search: aString

	"This method demsontrates the complex query functionality Magma supports.
	The first where clause uses doesNotUnderstand: to read the #title index in a very 
	intuitive manner.
	The second where cluase uses the more explicit but less terse method to read the
	#keywords index."

| result nextString |

nextString := aString maAlphabeticalNext.

result  := self inventory where: [ :each | each title between: aString and: nextString ].
 
result ifNotEmptyDo: [ : results | ^ self displayItems: results ]. 

result  := self inventory where:
		[ :reader |
			reader 
				read: #keywords
				from: aString
				to: nextString ].

result ifNotEmptyDo: [ : results | ^ self displayItems: results ]. 
 
^main inform: 'No items match ', aString printString  
				 ! !

!WAStoreFillCart methodsFor: '*seaside-examples-store-magma' stamp: 'cmm 11/2/2005 21:13'!
showOrders

	self show: WAStoreOrderView new! !

!WAStoreItem methodsFor: '*seaside-examples-store-magma' stamp: 'cmm 11/1/2005 00:36'!
keywords
	^ (title substrings, description substrings) asSet! !

!WAStoreTask methodsFor: '*seaside-examples-store-magma' stamp: 'brp 11/4/2005 12:19'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"Store the order in Magma"

	| order |
	order := WAOrder new
				cart: cart;
				shippingAddress: shippingAddress;
				billingAddress: billingAddress;
				creditCard: aCreditCard;
				yourself.

	self session commit: [ self session root orders add: order ].


! !
WAStore initialize!
